%This script tests the routine  HBW_SPMP1D_Trg_FFT which 
%implements the method HBW_SPMP in 1D with a Trigonometrc dictionaty via FFT
%The signal is the Pop Piano clip (to change it change 'wavfile' below)
%By default the partition is of length Nb=4096 (to change it change 'Nb' below)
%The approximation is up to SNR=35dB (to change it change 'pss' below)
%The dictionary is a mixed Cos U Sin dictionary (icase=4)
%The redundancy is a=4 (to change it change 'a' below).

%=====================================================
%Note: to deactivate the self-projections change lstep 
%to lstep=-1 below and the routine will run MPTrgFFT
%=====================================================
%
wavfile='ACHA2/Signals/pop_piano_acha.wav'
%wavfile='ACHA2/Signals/guitar_acha.wav'
[signal,fs]=audioread(wavfile); %read the music file
%
%settings
%
Nb=4096;% length of the partition unit
pss=35  %target SNR
icase=4 %dictionary type
a=4  %redundancy
lstep=1; %change to -1 to cancel self-projections
%
%end settings

[s1,s2]=size(signal);
if s1< s2; signal=signal';end
f=signal';
%
%
tic;
L=Nb
N=Nb*a
%
[nordt]=NormTrgDict(Nb,a,icase); %get the normalization factors
%
clear eex
eex=[]; %phase factors for  inner products via FFT
M=N; 
if icase==4 M=N/2;end  %cosine \cup sin dictionary
k=1:M;
if icase==2 | icase ==4 % icase 2 cosine dictionary
eex(1,:)=exp(-pi*1i*(k-1)/(2*M))./nordt(1,:);
end
if icase==3 %sine dictionary
eex(1,:)=exp(-pi*1i*(k)/(2*M))./nordt(1,:);;
end
if icase==4
eex(2,:)=exp(-pi*1i*(k)/(2*M))./nordt(2,:);;
end

%
%
s=floor(numel(f)/Nb);
mf=f(1:s*Nb);%resize the signal to be divisible by Nb
Nx=numel(mf);
Nframe=Nx/Nb; %number of frames
t0=1;
cmf=cell(Nframe,1);
%
for j=1:Nframe;
t=t0:t0+Nb-1;
t0=t0+Nb;
cmf{j}=mf(t);
end
%======end the segmentation each cmf is a cell with a frame or size Nb===
NBX=Nframe;
delta=1;
%
%
No=numel(f); %change to fix the number of atoms
mfc=cell(Nframe,1);
c=cell(Nframe,1);
zero_frame=0;
Max=500000; % Max number of iterations
Maxp=500000;% Max number of iterations for the projections
toln=5e-4; %tolerance error for the projection
LN=[L N];
%
%=============Start the approxiamtion of each block=========
%
clear c0 D0 Di0 beta0 c0 Q0 h cbeta cQ cD c cDi1 kap mk cf cf2 cfs nf
tic;
cf=zeros(N,Nframe);
tol3=(norm(mf)^2/(10^(pss/10)));
if lstep==1
[h,Di1,c,Nat]=HBW_SPMP1_Trg_FFT(cmf,LN,tol3,No,eex,icase,toln,Maxp,Max); for q=1:NBX;c{q}=c{q}';end;
   else
[h,Di1,c,Nat]=HBW_MP1_Trg_FFT(cmf,LN,tol3,No,eex,icase,toln,Maxp,Max); for q=1:NBX;c{q}=c{q}';end;
end
%=====================================================================
fa=[];
for i=1:Nframe
h{i}=h{i}';
fa=[fa h{i}];%assemble the whole signal from the partition
end
fprintf('===============================================\n')
;
%
 fprintf(' Sparsity Ratio SR.\n');
%

SR= numel(mf)/Nat% Sparsity ratio
nCoe=Nat %numer of atoms
%
toc
 fprintf(' Approximation quality SNR.\n');
%
SNR= CalcSNR(mf,fa)
fprintf('===============================================\n')
MSE=norm(fa-mf)^2/numel(mf); % MSE of the approximation
noise=fa-mf;
mean_noise=mean(noise)
var_noise=var(noise)
return
