%This script tests the routine SPMPTrgFFT (SPMP with Trigonometric dicitonary via FFT)
%The signal is the  'Csharp5.baroque.wav' flute tone
%The approximation is up to SNR=35dB (to change it 
%change 'pss' below)
%The dictionary is a mixed Cos U Sin dictionary (icase=4) 
%The redundancy is a=4 (to change it change 'a' below).

%=====================================================
%Note: to deactivate the self-projections change lstep 
%to lstep=-1 below and the routine will run MPTrgFFT
%=====================================================
%
wavfile='ACHA2/Signals/Csharp5.baroque.wav'
%wavfile='ACHA/Signals/guitar_acha.wav'

[signal,fs]=audioread(wavfile); %read the music file
%
%settings
%
Nb=numel(signal)% length of the partition unit
pss=35  %target SNR 
icase=4 %dictionary type
a=4  %redundancy
lstep=1; %change to -1 to cancel self-projections
%
%end settings

[s1,s2]=size(signal);
if s1< s2; signal=signal';end
f=signal';
%
%
tic;
L=Nb
N=Nb*a
%
[nordt]=NormTrgDict(Nb,a,icase); %get the normalization factors
%
clear eex
eex=[]; %phase factors for  inner products via FFT
M=N; 
if icase==4 M=N/2;end  %cosine \cup sin dictionary
k=1:M;
if icase==2 | icase ==4 % icase 2 cosine dictionary
eex(1,:)=exp(-pi*1i*(k-1)/(2*M))./nordt(1,:);
end
if icase==3 %sine dictionary
eex(1,:)=exp(-pi*1i*(k)/(2*M))./nordt(1,:);;
end
if icase==4
eex(2,:)=exp(-pi*1i*(k)/(2*M))./nordt(2,:);;
end

%
%
s=floor(numel(f)/Nb);
mf=f(1:s*Nb);%resize the signal to be divisible by Nb 
Nx=numel(mf);
Nframe=Nx/Nb; %number of frames
t0=1;
cmf=cell(Nframe,1);
%
for j=1:Nframe;
t=t0:t0+Nb-1;
t0=t0+Nb;
cmf{j}=mf(t);
end
%======end the segmentation each cmf is a cell with a frame or size Nb===
NBX=Nframe;
delta=1;
%
indx=[]; %do not touch 
%
No=Nb;
mfc=cell(Nframe,1);
c=cell(Nframe,1);
nCoe=0;
zero_frame=0;
Max=20000; % Max number of iterations
Maxp=20000;% Max number of iterations for the projections
toln=5e-4; %tolerance error for the projection
LN=[L N];
%
%=============Start the approxiamtion of each block=========
%
clear c0 D0 Di0 beta0 c0 Q0 h cbeta cQ cD c cDi1 kap mk
tic;
for j=1:Nframe;
tol=sqrt(norm(cmf{j})^2/(10^(pss/10)));
if (norm(cmf{j})^2)*delta>1e-5%avoids to try and approximate a zero block 

[h{j}, cDi1{j},c{j},kap{j}]= SPMPTrgFFT(cmf{j},LN,tol,No,toln,lstep,Max,Maxp,indx,eex,icase);
%======== save the coefficients and indices and approximated block 
k0=numel(cDi1{j});
cc{j}=c{j}(cDi1{j});
c{j}=cc{j}';
if lstep ~=-1 
mk(j)=mean(kap{j});
end
nCoe = nCoe + k0; %number of coefficients in the frames
else
nCoe = nCoe + 1;     %counts 1 coefficient per zero frame )
num_zero_blocks=zero_frame+1 %numbers of zero frame
h{j}=zeros(Nb,1)';
c{j}=zeros(1,1);
cDi1{j}=zeros(1,1);
end
end
toc
%
%=====================================================================
fa=[];
for i=1:Nframe
%h{i}=h{i}';
fa=[fa h{i}];%assemble the whole signal from the partition
end
fprintf('===============================================\n')
;
%
 fprintf(' Sparsity Ratio SR.\n');
%
SR= numel(mf)/nCoe% Sparsity ratio
nCoe %numer of atoms
%
 fprintf(' Approximation quality SNR.\n');
%
SNR= CalcSNR(mf,fa)
fprintf('===============================================\n')
MSE=norm(fa-mf)^2/numel(mf); % MSE of the approximation
if lstep ~= -1
mean_projection_times=mean(mk)
end
