function [h,c,ka]=ProjMPk(h,Re,V,c,toln,Max)
%
% ProjMP Projected Matching Pursuit 
%
% It uses the MP method for projecting the MP solution onto the spann of selected atoms
% 
%
% Usage:    [h, c] = ProjMP(Re,h V,c,toln,Max);
%
%
% Inputs:
%   Re     Residual of MP
%   h      Approximation by MP
%   D      Dictionary selected by MP
%   toln   numerical tolerance for the projection  
%   Max    maximum number of iterations
%
% Outputs:
%   h     projected approximation  
%   c     coefficients in the decomposition
%
%
%  see also OMP OOMP BOOMP Swapping OMPSwapping etc

%  More information at http://www.nonlinear-approx.info/
%
%setting defauls
%
%if (nargin<6) | (isempty(Max)==1)  Max=50000;end
%if (nargin<5) | (isempty(toln)==1) toln =1e-4;end
%
name='ProjMP';
l=length(c);
[L,N]=size(V);
delta=1;
tol2=1e-11;
ka=0;
%Iniciate the  iterations
for it=1:Max;
      cc=abs(Re*V);
      cc=(Re*V);
      [max_c,q]=max(abs(cc));
      if max_c < tol2 
      fprintf('%s stopped, max(|<f,D>|)<= tol2=%g.\n',name,tol2); break;
      end
      cscra=cc(q);
      h_new=cscra*V(:,q)';
      c(q)=c(q)+cscra;
      h=h+h_new;
      Re=Re-h_new;%computes the new residual 
      nor_new=norm(Re); 
      ka=ka+1;
      if  (norm(h_new)*sqrt(delta) <= toln) break;end;
end
if it==Max fprintf('%s stopped, maximum number of iterations has been reached,\n',name);
end

%===Laura Rebollo-Neira, 2010===
%Maths Department, Aston Uni, UK
%===============================
