function[IPTrg]=IPTrgFFT(Re,M,pha,option);
%Calculate the Inner product with Trigonometric Dictionaries
%via FFT 

%Inputs Re vector to calculate the inner product with
%       M  Number of atoms in the dictionary
%       pha auxiliary vector with phace values
%       option  for dictionary 1 Exp Fourier, 2 Cosine, 3 Sine

L= length(Re);
switch option
   case 1
    IPTrg=fft(Re,N)*sqrt(1/L);
   case 2
    cf=fft(Re,2*M);
    IPTrg=real(pha(1,:).*cf(1:M));
   case 3
    cf=fft(Re,2*M);
    cf(1)=[];
    IPTrg=-imag(pha(1,:).*cf(1:M));
otherwise
    disp('unknown option');
end
